OnPlayerDamage( eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime )
{
	if (gm\Variables::GetGMVar("gm_hitbox_damage_mod_enabled", false))
	{
		if (sMeansOfDeath == "MOD_MELEE")
		{
			if(gm\Variables::GetGMVar("gm_knife_use_hitbox_modifiers", false))
			{
				iDamage = LocationDamageAdjust(iDamage, sHitLoc);
			}
		}
		else
			iDamage = LocationDamageAdjust(iDamage, sHitLoc);
	}
		
	return iDamage;
}

OnPlayerKilled(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration)
{
	
}

LocationDamageAdjust(Damage, HitLoc)
{
	return Damage * gm\Variables::GetGMVar("gm_hitbox_damage_mod_" + HitLoc, 1.0);
}

PlayerSilentADSMain()
{
	self endon( "disconnect" );
	while(true)
	{
		self waittill( "spawned" );
		if (self HasPerk("specialty_quieter"))
			continue;
			
		self thread PlayerWatchForADS();		
	}
}

PlayerWatchForADS()
{
	self endon( "killed_player" );
	silenced = false;
	while(true)
	{
		ads = self playerads();
		
		if (!silenced && ads == 1.0)
		{
			self SetPerk("specialty_quieter");
			silenced = true;
		}
		else if (silenced && ads != 1.0)
		{
			self UnsetPerk("specialty_quieter");
			silenced = false;
		}
		wait .01;
	}
}

OnPlayerSpawned()
{
	self endon("disconnect");
	while (true)
	{
		self waittill("spawned_player");
		// do whatever when a player spawns
		game_state = gm\Variables::GetGMVar("game_state", "playing");
		if (game_state == "strat_time" || game_state == "timeout")
		{		
			self freezecontrols(true);
			if (game_state == "timeout")
				self EnableInvulnerability();
		}
		
		sprint_time = getdvarint("scr_player_sprinttime");
		self SetSprintDuration(sprint_time);
	}
}

OnPlayerJoinedTeam()
{
	self endon("disconnect");
	while (true)
	{
		self waittill("joined_team");
		game_state = gm\Variables::GetGMVar("game_state", "playing");
		
		if (game_state == "readyup")
		{
			self gm\Readyup::ReadyUpReset();
		}
	}	
}