#include gm\_Util;
#include gm\HUD;
#include gm\Variables;

ActivateStratTime(Duration)
{
	level waittill("prematch_over");
	
	game_state = GetGMVar("game_state", "playing");
	SetGMVar("game_state", "strat_time");
	
	players = getentarray("player", "classname");
	
	for(i = 0; i < players.size; i++)
	{
		players[i] freezecontrols(true);
		anchor = spawn("script_origin", players[i].origin);
		players[i] linkto(anchor);
	}
		
	maps\mp\gametypes\_globallogic_utils::pauseTimer();
	
	InitStratTimeHUD();
	
	while (duration >= 0)
	{
		UpdateStratTimeHUD(int(Duration));
		wait 0.1;
		duration -= 0.1;		
	}		
		
	DestroyStratTimeHUD();
	
	//regrab the player list in case we get a new player
	//(typically timeouts are used when a player drops)
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		players[i] unlink();
		players[i] freezecontrols(false);		
	}
	
	SetGMVar("game_state", game_state);
	maps\mp\gametypes\_globallogic_utils::resumeTimer();
}

InitStratTimeHUD()
{
	AddHUDElement("strattime_hud", CreateHUDElement(320, 100, "center", "middle", "default", 1.4, true, "Strat Time:", (0, 0, 0)));
}

DestroyStratTimeHUD()
{	
	RemoveHUDElement("strattime_hud");
}

UpdateStratTimeHUD(Timeleft)
{
	hud = GetHUDElement("strattime_hud");
	if (isDefined(hud))
		hud setText("Strat Time: " + Timeleft);	
}