Main()
{
	level thread OnConnectLoop();
	//level thread OnDisconnectLoop();
}

OnConnectLoop()
{
	while(true)
	{
		level waittill("connecting", player);
		
		player OnClientConnected();
		
		if (gm\Variables::GetGMVar("gm_silent_ads", true))
			player thread gm\PlayerCallbacks::PlayerSilentADSMain();
			
		if (gm\Variables::GetGMVar("gm_timeout_count", 0))
			player thread gm\Timeout::TimeoutMonitor();
			
		player thread gm\PlayerCallbacks::OnPlayerSpawned();
		player thread gm\PlayerCallbacks::OnPlayerJoinedTeam();
	}	
}

OnDisconnectLoop()
{
	while(true)
	{
		level waittill("disconnect"); 
	}
}

OnClientConnected()
{
	// force client side dvars
	self SetClientDvar("gm_fx_ambient_sound_enabled", gm\Variables::GetGMVar("gm_fx_ambient_sound_enabled", true));
	
	if (gm\Variables::GetGMVar("gm_knife_autoaim_enabled", true))
	{
		self SetClientDvars("aim_automelee_enabled", "0", 
							"aim_automelee_range", "0");		
	}
	else
	{
		range = gm\Variables::GetGMVar("gm_knife_autoaim_range", 128);
		self SetClientDvars("aim_automelee_enabled", "1", 
							"aim_automelee_range", range);
	}
	
	if (gm\Variables::GetGMVar("gm_headbob_enabled", true))
	{
		self setClientDvars("bg_bobMax", "8",
							"bg_bobAmplitudeStanding", "0.007 0.007",
							"bg_bobAmplitudeSprinting", "0.02 0.014",
							"bg_bobAmplitudeDucked", "0.0075 0.0075",
							"bg_bobAmplitudeProned", "0.02 0.005");
	}
	else
	{
		self setClientDvars("bg_bobMax", "0",
							"bg_bobAmplitudeStanding", "0 0",
							"bg_bobAmplitudeSprinting", "0 0",
							"bg_bobAmplitudeDucked", "0 0",
							"bg_bobAmplitudeProned", "0 0");
	}
	
	self setClientDvars("bg_fallDamageMinHeight", gm\Variables::GetGMVar("gm_fall_damage_min_height", 256),
						"bg_fallDamageMaxHeight", gm\Variables::GetGMVar("gm_fall_damage_max_height", 480),
						"cg_crosshairEnemyColor", gm\Variables::GetGMVar("gm_allow_red_enemy_crosshairs", true),
						"cg_drawcrosshairnames", gm\Variables::GetGMVar("gm_allow_red_enemy_crosshairs", true));
	
	//set dvar restrictions for the client
	restrictions = gm\Variables::GetGMVar("gm_client_dvar_restrictions", []);
	keys = GetArrayKeys(restrictions);
	
	for (i = 0; i < keys.size; i++)
	{
		dvar = keys[i];
		self SetClientDvar("gm_dvarmon_" + dvar, restrictions[dvar]);
	}
	
	self SetClientDvar("gm_dvar_violation_mode", "limit");
}

OnClientDisconnected()
{

}