Main()
{
	if (getdvar("g_gametype") == "dm")
		return;

	level thread OnPlayerConnect();
}

CreatePlayerHUD()
{
	friendly_alive_hud = gm\HUD::CreateClientHUDElement(self, 10, 250, "right", "middle", "default", 1.0, true, "", (1, 1, 0));
	enemy_alive_hud = gm\HUD::CreateClientHUDElement(self, 10, 270, "right", "middle", "default", 1.0, true, "", (1, 1, 0));
	
	self gm\HUD::AddPlayerHUDElement("TeammatesAlive", friendly_alive_hud);
	self gm\HUD::AddPlayerHUDElement("EnemiesAlive", enemy_alive_hud);
}

OnPlayerConnect()
{
	while(1)
	{
		level waittill("connecting", player);
		
		player CreatePlayerHUD();

		player thread OnPlayerSpawned();
		player thread OnPlayerKilled();
		player thread OnJoinedTeam();
		player thread OnJoinedSpectators();	
	}
}

OnJoinedTeam()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("joined_team");
		self RefreshPlayerHUDs();
	}
}

OnPlayerSpawned()
{
	self endon("disconnect");
	
	while(1)
	{
		self waittill("spawned_player");
		self RefreshPlayerHUDs();
	}
}

OnJoinedSpectators()
{
	self endon("disconnect");
	
	while(1)
	{
		self waittill("joined_spectators");
		self RefreshPlayerHUDs();
	}
}

OnPlayerKilled()
{
	self endon("disconnect");

	while(1)
	{
		self waittill("killed_player");
		self RefreshPlayerHUDs();
	}
}

RefreshHUD()
{		
	friendly_alive = 0;
	enemy_alive = 0;
	
	if (self.pers["team"] == "axis")
	{
		friendly_alive = GetTeamPlayersAlive("axis");
		enemy_alive = GetTeamPlayersAlive("allies");
	}
	else if (self.pers["team"] == "allies")
	{
		friendly_alive = GetTeamPlayersAlive("allies");
		enemy_alive = GetTeamPlayersAlive("axis");
	}
		
	if (self.pers["team"] == "spectator")
	{
		self gm\HUD::GetPlayerHUDElement("TeammatesAlive") SetText("Axis:   " + GetTeamPlayersAlive("axis"));		
		self gm\HUD::GetPlayerHUDElement("EnemiesAlive") SetText("Allies: " + GetTeamPlayersAlive("allies"));
	}
	else
	{
		self gm\HUD::GetPlayerHUDElement("TeammatesAlive") SetText("Teammates: " + friendly_alive);		
		self gm\HUD::GetPlayerHUDElement("EnemiesAlive") SetText("Enemies:   " + enemy_alive);
	}	
}

RefreshPlayerHUDs()
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		players[i] RefreshHUD();		
	}
}